#!/usr/bin/perl
$LOG = "/opt/bldlog";
$KERN_ERR = "/opt/errlog";
$PKGBASE = "/opt/esb-rhas21-beta_1_rc1";
$TARGET = "-e.24esbsmp";

print "\nPRIOR to running this script you must perform following steps:\n";
print "1 Set \$PKGBASE to match name of esb-rhas21-xxxx you are trying to install\n";
print "  > Edit this file (bldkernel.pl) to change the \$PKGBASE variable <\n";
print "2 Copy kernel-source-2.4.9-e.24.i386.rpm...\n";
print "  FROM: YOUR Red Hat Advanced Server v2.1 CDROMS\n";
print "  TO:   \${PKGBASE}/sources/kernel directory\n\n";
print "Press Y to continue or N to exit...\n";
$tmp1 = <STDIN>;
chomp $tmp1;

if (($tmp1 eq "Y") || ($tmp1 eq "y")) {
  goto START;
}
goto EXIT;

START:
 
#remove old log files

chdir ( "/opt" );

if ( -f "${LOG}" ) {
    system ( "rm -f ${LOG}" );
}
if ( -f "${KERN_ERR}" ) {
    system ( "rm -f ${KERN_ERR}" );
}

#create new log files

if ( ! -f "${LOG}" ) {
    system ( "touch ${LOG}" );
}
if ( ! -f "${KERN_ERR}" ) {
    system ( "touch ${KERN_ERR}" );
}

#goto WDT1;

KERN1:

chdir ("/usr/src");
print "Deleting /usr/src/linux-2.4.9-e.24...\n";
system ( "rpm -e kernel-source-2.4.9-e.24" );

print "Installing kernel sources from kernel-source-2.4.9-e.24.i386.rpm...\n"; 
chdir ("${PKGBASE}/sources/kernel");
system ( "rpm -i kernel-source-2.4.9-e.24.i386.rpm" );

KERN2:

chdir ("/usr/src/linux-2.4.9-e.24");

print "patch -p0 < ${PKGBASE}/patches/ide-sata/ide-pci.c-hr.patch\n";
system ( "patch -p0 < ${PKGBASE}/patches/ide-sata/ide-pci.c-hr.patch >>$LOG 2>>$KERN_ERR");

print "patch -p0 < ${PKGBASE}/patches/ide-sata/pci_ids.h-hr.patch\n";
system ( "patch -p0 < ${PKGBASE}/patches/ide-sata/pci_ids.h-hr.patch >>$LOG 2>>$KERN_ERR");

print "patch -p0 < ${PKGBASE}/patches/ide-sata/pci-irq.c-hr.patch\n";
system ( "patch -p0 < ${PKGBASE}/patches/ide-sata/pci-irq.c-hr.patch >>$LOG 2>>$KERN_ERR");

print "patch -p0 < ${PKGBASE}/patches/ide-sata/piix.c-hr.patch\n";
system ( "patch -p0 < ${PKGBASE}/patches/ide-sata/piix.c-hr.patch >>$LOG 2>>$KERN_ERR");

print "patch -p0 < ${PKGBASE}/patches/lspci/pci.ids-hr.patch\n";
system ( "patch -p0 < ${PKGBASE}/patches/lspci/pci.ids-hr.patch >>$LOG 2>>$KERN_ERR");

print "BEGIN kernel build process...\n";

print "Setting kernel Makefile EXTRAVERSION = $TARGET\n";
system ( "perl -pi~ -e 's/EXTRAVERSION = -e.24custom/EXTRAVERSION = $TARGET/' Makefile");

print "Creating .config file ...\n";
system ("cp ${PKGBASE}/sources/kernel/config-2.4.9-e.24-p4-smp-i2c .config");

KERN3:

print "Building the kernel...\n";

print "make oldconfig dep clean bzImage modules modules_install install\n";
system ("make oldconfig >>$LOG 2>>$KERN_ERR");
system ("make dep >>$LOG 2>>$KERN_ERR");
system ("make clean >>$LOG 2>>$KERN_ERR");
system ("make bzImage >>$LOG 2>>$KERN_ERR");
system ("make modules >>$LOG 2>>$KERN_ERR");
system ("make modules_install >>$LOG 2>>$KERN_ERR");
system ("make install >>$LOG 2>>$KERN_ERR");

KERN4:

chdir ("/boot");
print "mkinitrd initrd-2.4.9${TARGET}.img 2.4.9${TARGET}\n"; 
system ( "mkinitrd initrd-2.4.9${TARGET}.img 2.4.9${TARGET}" );

print "Configuring grub.conf to force boot with newly built kernel...\n";
system ( "patch -p0 < ${PKGBASE}/sources/kernel/install-2.4.9-e.24esbsmp.patch >>$LOG 2>>$KERN_ERR");


print "Installing newly built pci.ids file to /usr/src/pci.ids...\n";
system ( "cp /usr/src/linux-2.4.9-e.24/drivers/pci/pci.ids /usr/share/pci.ids" );

EXIT:

print "SMP kernel build complete...\n";
print "SMP kernel install complete...\n";
print "REBOOT TO THE 2.4.9-e.24esbsmp kernel \n";
print "Run the bldsmpdrivers.pl script to complete smp installation \n";

